﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Text;
using System.Windows.Input;
using Xamarin.Forms;
using XamarinArchitecture.Models;
using XamarinToolkit.Mvvm;

namespace XamarinArchitecture.ViewModels
{
    public class MainViewModel : ViewModelBase
    {
        private string _newTodoItemText = "";

        public string NewTodoItemText
        {
            get => _newTodoItemText;
            set
            {
                _newTodoItemText = value;
                OnPropertyChanged();
                OnPropertyChanged(nameof(CanAddTodoItem));
            }
        }

        public bool CanAddTodoItem => NewTodoItemText?.Length > 0;

        private ObservableCollection<TodoItem> _todos = new ObservableCollection<TodoItem>();

        public ObservableCollection<TodoItem> Todos
        {
            get => _todos;
            set
            {
                _todos = value;
                OnPropertyChanged();
            }
        }

        private Command _addTodoCommand;
        public Command AddTodoCommand => _addTodoCommand ?? (_addTodoCommand = new Command(AddTodo));

        private void AddTodo()
        {
            var newTodo = new TodoItem()
            {
                Text = NewTodoItemText
            };

            Todos.Add(newTodo);
            NewTodoItemText = string.Empty;
        }

        private Command<TodoItem> _deleteTodoCommand;
        public Command<TodoItem> DeleteTodoCommand => _deleteTodoCommand ?? (_deleteTodoCommand = new Command<TodoItem>((param) => DeleteTodo(param)));

        private void DeleteTodo(TodoItem todoItem)
        {
            Todos.Remove(todoItem);
        }
    }
}